<?php

/*
 ============================================================
CMSimple Plugin TG_popUP XH
============================================================
Version:  1.3
Released: 2012-5
Author:		Thomas Gärtner - www.tg-media-design.de
============================================================
With this plugin you can pop-up minimized images in a
lightbox.
Tested with CMSimple_XH 1.43
============================================================
utf-8 marker: äöüß
============================================================
change log:
1.3: added max_size support
*/

/**************************************************************************************************
 * tg_popup  plug-in for CMSimple_XH by Thomas Gärtner (c) 2011
* uses colorbox from http://colorpowered.com/ with jQuery
* and prettyPhoto from http://www.no-margin-for-errors.com/projects/prettyphoto-jquery-lightbox-clone/
* ************************************************************************************************/

$generate_global = $plugin_cf['tg_popup']['generate_global'];

// If configured as global, generate thumbs of all images
if (($generate_global == 'ON') AND !$edit AND !((locator() == '&nbsp;') AND isset($rq))) {
	if ($f == '') {  // if not e.g. sitemap or mailform
		if ($s == -1) {
			$s = 0;
		}
		$c[$s] = tg_popup($c[$s]);
	}
}


/**
 * parse html code and replace img-tag for thumbnail
 * @param string $content
 * @param string $rel
 * @return string
 */
function tg_popup($content, $rel='popup') {
	global $sl, $cf, $hjs, $pth, $plugin_cf;
	$plugin = basename(dirname(__FILE__),"/");
	$path = $pth['folder']['plugins'].$plugin.'/';
	$is_default = ($sl == $cf['language']['default']); // Is default language?
	$cf_max_w = $plugin_cf['tg_popup']['max_img_width'];
	$cf_max_h = $plugin_cf['tg_popup']['max_img_height'];
	$set_max_size = $plugin_cf['tg_popup']['set_max_size'];

	// include jQuery file once
	include_once($pth['folder']['plugins'].'jquery/jquery.inc.php');
	//include jQuery to the <head>
	include_jQuery();

	// reset $new_content
	$new_content = '';
	// temporary actual content
	$C_temp = $content;
	$is_bigger = false;
	$rel_array = array();
	// --------------- change content if necessary ----------------
	if(strpos($C_temp, '<img') || is_int(strpos($C_temp, '<img'))) {
		// img-tag exists
		$ci = 0;
		while (strpos($C_temp, '<img') !== false) {

			unset($thumb_width);
			unset($thumb_height);
			unset($src);
			unset($img_tag);

			$pos_img_b = strpos($C_temp, '<img');
			$new_content .= substr($C_temp, 0, $pos_img_b);
			$C_temp = substr($C_temp, $pos_img_b);
			$img_offset = strpos($C_temp, '>');
			$img_tag = substr($C_temp, 0, $img_offset+1);
			$rest = substr($C_temp, $img_offset+1);
			$src = get_attribute_value($img_tag, 'src');   // source of $img_tag
			// $src = dirname($src).'/'.urlencode(basename($src));
			$thumb_width = (int) get_attribute_value($img_tag, 'width');    // width of $img_tag
			$thumb_height = (int) get_attribute_value($img_tag, 'height');    // height of $img_tag
			$alt = get_attribute_value($img_tag, 'alt');    // alt of $img_tag
			$alt = ($alt !== false) ? $alt : '';

			// image size
			$imagesize = getimagesize(urldecode($src));
			$org_width = (int)$imagesize[0];
			$org_height = (int)$imagesize[1];
			$type = $imagesize[2];

			// original bigger than thumb ?
			if (($org_width > $thumb_width AND $thumb_width > 0) OR ($org_height > $thumb_height AND $thumb_height > 0)) {
				$is_bigger = true;
				$ci++;
				
				$rel_path = ($is_default) ? './' : '../';
				$thumb_rel_path =  '../../';
				$tsrc = str_replace($rel_path, $thumb_rel_path, $src, $count);
				if ($count == 0) {
					$tsrc = $thumb_rel_path.$src;
				}
				$thumb_src = get_resized_thumb_src($path, $tsrc, $thumb_width, $thumb_height);
				
				$img_tag = str_replace($src, $thumb_src, $img_tag);

				$rel_array[$ci] = $rel;

				switch ($plugin_cf['tg_popup']['lightbox']) {
					case 'colorbox':
						$rel_val = $rel;
						break;

					case 'prettyPhoto':
						$rel_val = 'prettyPhoto['.$rel.']';
						break;

					default:
						break;
				}
				// check if set max size is switched on
				if ($set_max_size == 'ON') {
					// resize popup if adjusted and original image is bigger
					if (($org_width > $cf_max_w AND $org_width > $thumb_width)  OR ($org_height > $cf_max_h AND $org_height > $thumb_height)) {
						$src = get_resized_thumb_src($path, $tsrc, $cf_max_w, $cf_max_h);
					}
				}

				$new_content .= '<a href="'.$src.'" rel="'.$rel_val.'" title="'.$alt.'">'.$img_tag.'</a>';
			}
			else {
				$new_content .= $img_tag;
			}
			$C_temp = $rest;
		}
	}

	if ($is_bigger) {

		// java script code in head tag
		switch ($plugin_cf['tg_popup']['lightbox']) {
			case 'colorbox':
				include_jQueryPlugin('colorbox', $path.'js/jquery.colorbox-min.js');
				// jQuery code in head tag
				jQuery_docReady('$("a[rel='.$rel.']").colorbox();');
				break;

			case 'prettyPhoto':
				include_jQueryPlugin('prettyPhoto', $path.'js/jquery.prettyPhoto.js');
				jQuery_docReady('$("a[rel^=\'prettyPhoto\']").prettyPhoto();');
				break;

			default:
				include_jQueryPlugin('colorbox', $path.'js/jquery.colorbox-min.js');
			jQuery_docReady('$("a[rel='.$rel.']").colorbox();');
			break;
		}
	}

	// append rest to output
	$new_content .= $C_temp;

	return $new_content;
}


function get_attribute_value($str, $attribute) {
	$a = $attribute.'="';
	$len = strlen($a);
	if (strpos($str, $a) > 0) {
		$pos_s = strpos($str, $a)+$len;
		$pos_e = strpos($str,'"',$pos_s);
		$off = $pos_e - $pos_s;
		return substr($str,$pos_s,$off);
	}
	else { return false;
	}
}

function get_resized_thumb_src($path, $src, $x, $y) {
	$str_thumb = $path.'thumb.php?image='.$src.'&amp;x='.$x.'&amp;y='.$y;
	return $str_thumb;
}

function jQuery_docReady($jqcode) {
	global $hjs;
	$hjs .= '<script type="text/javascript">$(document).ready(function(){ ';
	$hjs .= $jqcode;
	$hjs .= '}); </script>';
	return true;
}

?>